#include "IR.hpp"
#include "AST.hpp"
#include "ExpandModules.hpp"
#include <iostream>

int main()
{
  try {
    IR::Node *root;
    IR::XMListream r(std::cin);
    r >> root;

    AST::Modules *m = dynamic_cast<AST::Modules*>(root);
    if (!m) throw IR::Error("Root node is not a Modules node");

    AST::Modules *nm = ExpandModules::rewrite(m);
    assert(nm);

    IR::XMLostream w(std::cout);
    w << nm;
    
  } catch (IR::Error &e) {
    std::cerr << e.s << std::endl;
    return -1;
  }

  return 0;
}
